Index: trunk/NEMO/OPA_SRC/TRA/trabbl.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/trabbl.F90	(revision 1598)
+++ trunk/NEMO/OPA_SRC/TRA/trabbl.F90	(revision 1601)
@@ -35,5 +35,5 @@
 
    !!* Namelist nambbl: bottom boundary layer
-   REAL(wp), PUBLIC ::   atrbbl = 1.e+3   !: lateral coeff. for bottom boundary layer scheme (m2/s)
+   REAL(wp), PUBLIC ::   rn_ahtbbl = 1.e+3   !: lateral coeff. for bottom boundary layer scheme (m2/s)
 
 # if defined key_trabbl_dif
@@ -108,17 +108,15 @@
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step
       !!
-      INTEGER  ::   ji, jj                   ! dummy loop indices
+      INTEGER  ::   ji, jj                  ! dummy loop indices
       INTEGER  ::   ik
-      INTEGER  ::   ii0, ii1, ij0, ij1       ! temporary integers
+      INTEGER  ::   ii0, ii1, ij0, ij1      ! temporary integers
       INTEGER  ::   iku1, iku2, ikv1,ikv2   ! temporary intergers
       REAL(wp) ::   ze3u, ze3v              ! temporary scalars
       INTEGER  ::   iku, ikv
-      REAL(wp) ::   &
-         zsign, zt, zs, zh, zalbet,      &  ! temporary scalars
-         zgdrho, zbtr, zta, zsa
-      REAL(wp), DIMENSION(jpi,jpj) ::    &
-        zki, zkj, zkw, zkx, zky, zkz,    &  ! 2D workspace arrays
-        ztnb, zsnb, zdep,                &
-        ztbb, zsbb, zahu, zahv
+      REAL(wp) ::   zsign, zt, zs, zh, zalbet   ! temporary scalars
+      REAL(wp) ::   zgdrho, zbtr, zta, zsa
+      REAL(wp), DIMENSION(jpi,jpj) ::   zki, zkj, zkw, zkx, zky, zkz             ! 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj) ::   ztnb, zsnb, zdep, ztbb, zsbb, zahu, zahv
+      !!
       REAL(wp) ::    fsalbt, pft, pfs, pfh   ! statement function
       !!----------------------------------------------------------------------
@@ -132,14 +130,14 @@
       fsalbt( pft, pfs, pfh ) =                                              &
          ( ( ( -0.255019e-07 * pft + 0.298357e-05 ) * pft                    &
-                                   - 0.203814e-03 ) * pft                    &
-                                   + 0.170907e-01 ) * pft                    &
-                                   + 0.665157e-01                            &
+         &                         - 0.203814e-03 ) * pft                    &
+         &                         + 0.170907e-01 ) * pft                    &
+         &                         + 0.665157e-01                            &
          +(-0.678662e-05 * pfs - 0.846960e-04 * pft + 0.378110e-02 ) * pfs   &
          +  ( ( - 0.302285e-13 * pfh                                         &
-                - 0.251520e-11 * pfs                                         &
-                + 0.512857e-12 * pft * pft          ) * pfh                  &
-                                     - 0.164759e-06   * pfs                  &
-             +(   0.791325e-08 * pft - 0.933746e-06 ) * pft                  &
-                                     + 0.380374e-04 ) * pfh   
+         &      - 0.251520e-11 * pfs                                         &
+         &      + 0.512857e-12 * pft * pft          ) * pfh                  &
+         &                           - 0.164759e-06   * pfs                  &
+         &   +(   0.791325e-08 * pft - 0.933746e-06 ) * pft                  &
+         &                           + 0.380374e-04 ) * pfh   
       !!----------------------------------------------------------------------
 
@@ -155,6 +153,6 @@
       ! mbathy= number of w-level, minimum value=1 (cf dommsk.F)
 #  if defined key_vectopt_loop
-      jj = 1
-      DO ji = 1, jpij   ! vector opt. (forced unrolling)
+      DO jj = 1, 1
+         DO ji = 1, jpij   ! vector opt. (forced unrolling)
 #  else
       DO jj = 1, jpj
@@ -167,13 +165,11 @@
             zsbb(ji,jj) = sb(ji,jj,ik) * tmask(ji,jj,1)
             zdep(ji,jj) = fsdept(ji,jj,ik)                ! depth of the ocean bottom T-level
-#  if ! defined key_vectopt_loop
-         END DO
-#  endif
+         END DO
       END DO
 
       IF( ln_zps ) THEN      ! partial steps correction 
 # if defined key_vectopt_loop
-         jj = 1
-         DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
+         DO jj = 1, 1
+            DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
 # else
          DO jj = 1, jpjm1
@@ -186,14 +182,12 @@
                ze3u = MIN( fse3u(ji,jj,iku1), fse3u(ji,jj,iku2) ) 
                ze3v = MIN( fse3v(ji,jj,ikv1), fse3v(ji,jj,ikv2) ) 
-               zahu(ji,jj) = atrbbl * e2u(ji,jj) * ze3u / e1u(ji,jj) * umask(ji,jj,1)
-               zahv(ji,jj) = atrbbl * e1v(ji,jj) * ze3v / e2v(ji,jj) * vmask(ji,jj,1)
-# if ! defined key_vectopt_loop
+               zahu(ji,jj) = rn_ahtbbl * e2u(ji,jj) * ze3u / e1u(ji,jj) * umask(ji,jj,1)
+               zahv(ji,jj) = rn_ahtbbl * e1v(ji,jj) * ze3v / e2v(ji,jj) * vmask(ji,jj,1)
             END DO
-# endif
          END DO
       ELSE                    ! z-coordinate - full steps or s-coordinate
 #   if defined key_vectopt_loop
-         jj = 1
-         DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
+         DO jj = 1, 1
+            DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
 #   else
          DO jj = 1, jpjm1
@@ -202,9 +196,7 @@
                iku = mbku(ji,jj)
                ikv = mbkv(ji,jj)
-               zahu(ji,jj) = atrbbl * e2u(ji,jj) * fse3u(ji,jj,iku) / e1u(ji,jj) * umask(ji,jj,1)
-               zahv(ji,jj) = atrbbl * e1v(ji,jj) * fse3v(ji,jj,ikv) / e2v(ji,jj) * vmask(ji,jj,1)
-#   if ! defined key_vectopt_loop
+               zahu(ji,jj) = rn_ahtbbl * e2u(ji,jj) * fse3u(ji,jj,iku) / e1u(ji,jj) * umask(ji,jj,1)
+               zahv(ji,jj) = rn_ahtbbl * e1v(ji,jj) * fse3v(ji,jj,ikv) / e2v(ji,jj) * vmask(ji,jj,1)
             END DO
-#   endif
          END DO
       ENDIF
@@ -215,135 +207,88 @@
       ! multiplied by the slope of the ocean bottom
 
-      SELECT CASE ( neos )
-
-      CASE ( 0 )                 ! Jackett and McDougall (1994) formulation
-
-#  if defined key_vectopt_loop
-      jj = 1
-      DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
-#  else
-      DO jj = 1, jpjm1
-         DO ji = 1, jpim1
-#  endif
-            ! temperature, salinity anomalie and depth
-            zt = 0.5 * ( ztnb(ji,jj) + ztnb(ji+1,jj) )
-            zs = 0.5 * ( zsnb(ji,jj) + zsnb(ji+1,jj) ) - 35.0
-            zh = 0.5 * ( zdep(ji,jj) + zdep(ji+1,jj) )
-            ! masked ratio alpha/beta
-            zalbet = fsalbt( zt, zs, zh )*umask(ji,jj,1)
-            ! local density gradient along i-bathymetric slope
-            zgdrho = zalbet * ( ztnb(ji+1,jj) - ztnb(ji,jj) )   &
-                   -          ( zsnb(ji+1,jj) - zsnb(ji,jj) )
-            ! sign of local i-gradient of density multiplied by the i-slope
-            zsign = SIGN( 0.5, - zgdrho * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
-            zki(ji,jj) = ( 0.5 - zsign ) * zahu(ji,jj)
-#  if ! defined key_vectopt_loop
-         END DO
-#  endif
-      END DO
-
-#  if defined key_vectopt_loop
-      jj = 1
-      DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
-#  else
-      DO jj = 1, jpjm1
-         DO ji = 1, jpim1
-#  endif
-            ! temperature, salinity anomalie and depth
-            zt = 0.5 * ( ztnb(ji,jj+1) + ztnb(ji,jj) )
-            zs = 0.5 * ( zsnb(ji,jj+1) + zsnb(ji,jj) ) - 35.0
-            zh = 0.5 * ( zdep(ji,jj+1) + zdep(ji,jj) )
-            ! masked ratio alpha/beta
-            zalbet = fsalbt( zt, zs, zh )*vmask(ji,jj,1)
-            ! local density gradient along j-bathymetric slope
-            zgdrho = zalbet * ( ztnb(ji,jj+1) - ztnb(ji,jj) )   &
-                   -          ( zsnb(ji,jj+1) - zsnb(ji,jj) )
-            ! sign of local j-gradient of density multiplied by the j-slope
-            zsign = sign( 0.5, -zgdrho * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
-            zkj(ji,jj) = ( 0.5 - zsign ) * zahv(ji,jj)
-#  if ! defined key_vectopt_loop
-         END DO
-#  endif
-      END DO
-
-      CASE ( 1 )               ! Linear formulation function of temperature only
-                               ! 
-#  if defined key_vectopt_loop
-      jj = 1
-      DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
-#  else
-      DO jj = 1, jpjm1
-         DO ji = 1, jpim1
-#  endif
-            ! local 'density/temperature' gradient along i-bathymetric slope
-            zgdrho =  ztnb(ji+1,jj) - ztnb(ji,jj) 
-            ! sign of local i-gradient of density multiplied by the i-slope
-            zsign = SIGN( 0.5, - zgdrho * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
-            zki(ji,jj) = ( 0.5 - zsign ) * zahu(ji,jj)
-#  if ! defined key_vectopt_loop
-         END DO
-#  endif
-      END DO
-
-#  if defined key_vectopt_loop
-      jj = 1
-      DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
-#  else
-      DO jj = 1, jpjm1
-         DO ji = 1, jpim1
-#  endif
-            ! local density gradient along j-bathymetric slope
-            zgdrho =  ztnb(ji,jj+1) - ztnb(ji,jj) 
-            ! sign of local j-gradient of density multiplied by the j-slope
-            zsign = sign( 0.5, -zgdrho * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
-            zkj(ji,jj) = ( 0.5 - zsign ) * zahv(ji,jj)
-#  if ! defined key_vectopt_loop
-         END DO
-#  endif
-      END DO
-
-      CASE ( 2 )               ! Linear formulation function of temperature and salinity
-
-#  if defined key_vectopt_loop
-      jj = 1
-      DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
-#  else
-      DO jj = 1, jpjm1
-         DO ji = 1, jpim1
+      SELECT CASE ( nn_eos )
+      !
+      CASE ( 0 )                 !==  Jackett and McDougall (1994) formulation  ==!
+#  if defined key_vectopt_loop
+         DO jj = 1, 1
+            DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
+#  else
+         DO jj = 1, jpjm1
+            DO ji = 1, jpim1
+#  endif
+               ! temperature, salinity anomalie and depth
+               zt = 0.5 * ( ztnb(ji,jj) + ztnb(ji+1,jj) )
+               zs = 0.5 * ( zsnb(ji,jj) + zsnb(ji+1,jj) ) - 35.0
+               zh = 0.5 * ( zdep(ji,jj) + zdep(ji+1,jj) )
+               ! masked ratio alpha/beta
+               zalbet = fsalbt( zt, zs, zh )*umask(ji,jj,1)
+               ! local density gradient along i-bathymetric slope
+               zgdrho = zalbet * ( ztnb(ji+1,jj) - ztnb(ji,jj) )   &
+                      -          ( zsnb(ji+1,jj) - zsnb(ji,jj) )
+               ! sign of local i-gradient of density multiplied by the i-slope
+               zsign = SIGN( 0.5, - zgdrho * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
+               zki(ji,jj) = ( 0.5 - zsign ) * zahu(ji,jj)
+               !
+               ! temperature, salinity anomalie and depth
+               zt = 0.5 * ( ztnb(ji,jj+1) + ztnb(ji,jj) )
+               zs = 0.5 * ( zsnb(ji,jj+1) + zsnb(ji,jj) ) - 35.0
+               zh = 0.5 * ( zdep(ji,jj+1) + zdep(ji,jj) )
+               ! masked ratio alpha/beta
+               zalbet = fsalbt( zt, zs, zh )*vmask(ji,jj,1)
+               ! local density gradient along j-bathymetric slope
+               zgdrho = zalbet * ( ztnb(ji,jj+1) - ztnb(ji,jj) )   &
+                      -          ( zsnb(ji,jj+1) - zsnb(ji,jj) )
+               ! sign of local j-gradient of density multiplied by the j-slope
+               zsign = sign( 0.5, -zgdrho * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
+               zkj(ji,jj) = ( 0.5 - zsign ) * zahv(ji,jj)
+            END DO
+         END DO
+         !
+      CASE ( 1 )               !==  Linear formulation function of temperature only  ==!
+#  if defined key_vectopt_loop
+         DO jj = 1, 1
+            DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
+#  else
+         DO jj = 1, jpjm1
+            DO ji = 1, jpim1
+#  endif
+               ! local 'density/temperature' gradient along i-bathymetric slope
+               zgdrho =  ztnb(ji+1,jj) - ztnb(ji,jj) 
+               ! sign of local i-gradient of density multiplied by the i-slope
+               zsign = SIGN( 0.5, - zgdrho * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
+               zki(ji,jj) = ( 0.5 - zsign ) * zahu(ji,jj)
+               !
+               ! local density gradient along j-bathymetric slope
+               zgdrho =  ztnb(ji,jj+1) - ztnb(ji,jj) 
+               ! sign of local j-gradient of density multiplied by the j-slope
+               zsign = sign( 0.5, -zgdrho * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
+               zkj(ji,jj) = ( 0.5 - zsign ) * zahv(ji,jj)
+            END DO
+         END DO
+         !
+      CASE ( 2 )               !==  Linear formulation function of temperature and salinity  ==!
+#  if defined key_vectopt_loop
+         DO jj = 1, 1
+            DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
+#  else
+         DO jj = 1, jpjm1
+            DO ji = 1, jpim1
 #  endif      
-            ! local density gradient along i-bathymetric slope
-            zgdrho = - ( rbeta*( zsnb(ji+1,jj) - zsnb(ji,jj) )   &
-                     -  ralpha*( ztnb(ji+1,jj) - ztnb(ji,jj) ) )
-            ! sign of local i-gradient of density multiplied by the i-slope
-            zsign = SIGN( 0.5, - zgdrho * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
-            zki(ji,jj) = ( 0.5 - zsign ) * zahu(ji,jj)
-#  if ! defined key_vectopt_loop
-         END DO
-#  endif
-      END DO
-
-#  if defined key_vectopt_loop
-      jj = 1
-      DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
-#  else
-      DO jj = 1, jpjm1
-         DO ji = 1, jpim1
-#  endif     
-            ! local density gradient along j-bathymetric slope
-            zgdrho = - ( rbeta*( zsnb(ji,jj+1) - zsnb(ji,jj) )   &
-                     -  ralpha*( ztnb(ji,jj+1) - ztnb(ji,jj) ) )   
-            ! sign of local j-gradient of density multiplied by the j-slope
-            zsign = sign( 0.5, -zgdrho * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
-            zkj(ji,jj) = ( 0.5 - zsign ) * zahv(ji,jj)
-#  if ! defined key_vectopt_loop
-         END DO
-#  endif
-      END DO
-      
-      CASE DEFAULT
-
-         WRITE(ctmp1,*) '          bad flag value for neos = ', neos
-         CALL ctl_stop(ctmp1)
-
+               ! local density gradient along i-bathymetric slope
+               zgdrho = - ( rn_beta *( zsnb(ji+1,jj) - zsnb(ji,jj) )   &
+                  &       - rn_alpha*( ztnb(ji+1,jj) - ztnb(ji,jj) ) )
+               ! sign of local i-gradient of density multiplied by the i-slope
+               zsign = SIGN( 0.5, - zgdrho * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
+               zki(ji,jj) = ( 0.5 - zsign ) * zahu(ji,jj)
+               !
+               ! local density gradient along j-bathymetric slope
+               zgdrho = - ( rn_beta *( zsnb(ji,jj+1) - zsnb(ji,jj) )   &
+                  &       - rn_alpha*( ztnb(ji,jj+1) - ztnb(ji,jj) ) )   
+               ! sign of local j-gradient of density multiplied by the j-slope
+               zsign = sign( 0.5, -zgdrho * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
+               zkj(ji,jj) = ( 0.5 - zsign ) * zahv(ji,jj)
+            END DO
+         END DO
+         !
       END SELECT
 
@@ -403,6 +348,6 @@
       ! second derivative (divergence) and add to the general tracer trend
 #  if defined key_vectopt_loop
-      jj = 1
-      DO ji = jpi+2, jpij-jpi-1   ! vector opt. (forced unrolling)
+      DO jj = 1, 1
+         DO ji = jpi+2, jpij-jpi-1   ! vector opt. (forced unrolling)
 #  else
       DO jj = 2, jpjm1
@@ -417,7 +362,5 @@
             ta(ji,jj,ik) = ta(ji,jj,ik) + zta
             sa(ji,jj,ik) = sa(ji,jj,ik) + zsa
-#  if ! defined key_vectopt_loop
-         END DO
-#  endif
+         END DO
       END DO
 
@@ -460,5 +403,5 @@
       REAL(wp),  DIMENSION(jpi,jpj) :: zmbk  
 
-      NAMELIST/nambbl/ atrbbl
+      NAMELIST/nambbl/ rn_ahtbbl
       !!----------------------------------------------------------------------
 
@@ -470,8 +413,8 @@
          WRITE(numout,*) 'tra_bbl_init : '
          WRITE(numout,*) '~~~~~~~~~~~~'
-         IF (lk_trabbl_dif )   WRITE(numout,*) '               * Diffusive Bottom Boundary Layer'
+         IF( lk_trabbl_dif )   WRITE(numout,*) '               * Diffusive Bottom Boundary Layer'
          IF( lk_trabbl_adv )   WRITE(numout,*) '               * Advective Bottom Boundary Layer'
          WRITE(numout,*) '       Namelist nambbl : set bbl parameters'
-         WRITE(numout,*) '          bottom boundary layer coef.    atrbbl = ', atrbbl
+         WRITE(numout,*) '          bottom boundary layer coef.    rn_ahtbbl = ', rn_ahtbbl
       ENDIF
  
Index: trunk/NEMO/OPA_SRC/TRA/trabbl_adv.h90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/trabbl_adv.h90	(revision 1598)
+++ trunk/NEMO/OPA_SRC/TRA/trabbl_adv.h90	(revision 1601)
@@ -101,6 +101,6 @@
 
 #if defined key_vectopt_loop
-      jj = 1
-      DO ji = 1, jpij   ! vector opt. (forced unrolling)
+      DO jj = 1, 1
+         DO ji = 1, jpij   ! vector opt. (forced unrolling)
 #else
       DO jj = 1, jpj
@@ -116,7 +116,5 @@
             zunb(ji,jj) = un(ji,jj,mbku(ji,jj)) 
             zvnb(ji,jj) = vn(ji,jj,mbkv(ji,jj)) 
-#if ! defined key_vectopt_loop
-         END DO
-#endif
+         END DO
       END DO
 
@@ -127,91 +125,83 @@
       ! multiplied by the slope of the ocean bottom
 
-      SELECT CASE ( neos )
+      SELECT CASE ( nn_eos )
       !
       CASE ( 0 )               ! Jackett and McDougall (1994) formulation
-      !
-      DO jj = 1, jpjm1
-         DO ji = 1, fs_jpim1   ! vector opt.
-            !   ... temperature, salinity anomalie and depth
-            zt = 0.5 * ( ztnb(ji,jj) + ztnb(ji+1,jj) )
-            zs = 0.5 * ( zsnb(ji,jj) + zsnb(ji+1,jj) ) - 35.0
-            zh = 0.5 * ( zdep(ji,jj) + zdep(ji+1,jj) )
-            !   ... masked ratio alpha/beta
-            zalbet = fsalbt( zt, zs, zh ) * umask(ji,jj,1)
-            !   ... local density gradient along i-bathymetric slope
-            zgdrho = zalbet * ( ztnb(ji+1,jj) - ztnb(ji,jj) )   &
-               &       -      ( zsnb(ji+1,jj) - zsnb(ji,jj) )
-            zgdrho = zgdrho * umask(ji,jj,1)
-            !   ... sign of local i-gradient of density multiplied by the i-slope
-            zsign = SIGN( 0.5, -zgdrho     * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
-            zsigna= SIGN( 0.5, zunb(ji,jj) * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
-            zalphax(ji,jj)=( 0.5 + zsigna ) * ( 0.5 - zsign ) * umask(ji,jj,1)
-         END DO
-      END DO
-      !
-      DO jj = 1, jpjm1
-         DO ji = 1, fs_jpim1   ! vector opt.
-            !   ... temperature, salinity anomalie and depth
-            zt = 0.5 * ( ztnb(ji,jj+1) + ztnb(ji,jj) )
-            zs = 0.5 * ( zsnb(ji,jj+1) + zsnb(ji,jj) ) - 35.0
-            zh = 0.5 * ( zdep(ji,jj+1) + zdep(ji,jj) )
-            !   ... masked ratio alpha/beta
-            zalbet = fsalbt( zt, zs, zh ) * vmask(ji,jj,1)
-            !   ... local density gradient along j-bathymetric slope
-            zgdrho = zalbet * ( ztnb(ji,jj+1) - ztnb(ji,jj) )   &
-               &       -      ( zsnb(ji,jj+1) - zsnb(ji,jj) )
-            zgdrho = zgdrho*vmask(ji,jj,1)
-            !   ... sign of local j-gradient of density multiplied by the j-slope
-            zsign = SIGN( 0.5, -zgdrho     * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
-            zsigna= SIGN( 0.5, zvnb(ji,jj) * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
-            zalphay(ji,jj)=( 0.5 + zsigna ) * ( 0.5 - zsign ) * vmask(ji,jj,1)
-         END DO
-      END DO
-      !
+         !
+         DO jj = 1, jpjm1
+            DO ji = 1, fs_jpim1   ! vector opt.
+               !   ... temperature, salinity anomalie and depth
+               zt = 0.5 * ( ztnb(ji,jj) + ztnb(ji+1,jj) )
+               zs = 0.5 * ( zsnb(ji,jj) + zsnb(ji+1,jj) ) - 35.0
+               zh = 0.5 * ( zdep(ji,jj) + zdep(ji+1,jj) )
+               !   ... masked ratio alpha/beta
+               zalbet = fsalbt( zt, zs, zh ) * umask(ji,jj,1)
+               !   ... local density gradient along i-bathymetric slope
+               zgdrho = zalbet * ( ztnb(ji+1,jj) - ztnb(ji,jj) )   &
+                  &       -      ( zsnb(ji+1,jj) - zsnb(ji,jj) )
+               zgdrho = zgdrho * umask(ji,jj,1)
+               !   ... sign of local i-gradient of density multiplied by the i-slope
+               zsign = SIGN( 0.5, -zgdrho     * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
+               zsigna= SIGN( 0.5, zunb(ji,jj) * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
+               zalphax(ji,jj)=( 0.5 + zsigna ) * ( 0.5 - zsign ) * umask(ji,jj,1)
+               !
+               !   ... temperature, salinity anomalie and depth
+               zt = 0.5 * ( ztnb(ji,jj+1) + ztnb(ji,jj) )
+               zs = 0.5 * ( zsnb(ji,jj+1) + zsnb(ji,jj) ) - 35.0
+               zh = 0.5 * ( zdep(ji,jj+1) + zdep(ji,jj) )
+               !   ... masked ratio alpha/beta
+               zalbet = fsalbt( zt, zs, zh ) * vmask(ji,jj,1)
+               !   ... local density gradient along j-bathymetric slope
+               zgdrho = zalbet * ( ztnb(ji,jj+1) - ztnb(ji,jj) )   &
+                  &       -      ( zsnb(ji,jj+1) - zsnb(ji,jj) )
+               zgdrho = zgdrho*vmask(ji,jj,1)
+               !   ... sign of local j-gradient of density multiplied by the j-slope
+               zsign = SIGN( 0.5, -zgdrho     * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
+               zsigna= SIGN( 0.5, zvnb(ji,jj) * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
+               zalphay(ji,jj)=( 0.5 + zsigna ) * ( 0.5 - zsign ) * vmask(ji,jj,1)
+            END DO
+         END DO
+         !
       CASE ( 1 )               ! Linear formulation function of temperature only
-      !
-      DO jj = 1, jpjm1
-         DO ji = 1, fs_jpim1   ! vector opt.
-            ! local 'density/temperature' gradient along i-bathymetric slope
-            zgdrho =  ( ztnb(ji+1,jj) - ztnb(ji,jj) )
-            ! sign of local i-gradient of density multiplied by the i-slope
-            zsign = SIGN( 0.5, - zgdrho    * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
-            zsigna= SIGN( 0.5, zunb(ji,jj) * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
-            zalphax(ji,jj)=( 0.5 + zsigna ) * ( 0.5 - zsign ) * umask(ji,jj,1)
-
-            ! local density gradient along j-bathymetric slope
-            zgdrho =  ( ztnb(ji,jj+1) - ztnb(ji,jj) )
-            ! sign of local j-gradient of density multiplied by the j-slope
-            zsign = SIGN( 0.5, -zgdrho     * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
-            zsigna= SIGN( 0.5, zvnb(ji,jj) * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
-            zalphay(ji,jj)=( 0.5 + zsigna ) * ( 0.5 - zsign ) * vmask(ji,jj,1)
-         END DO
-      END DO
-      !
+         !
+         DO jj = 1, jpjm1
+            DO ji = 1, fs_jpim1   ! vector opt.
+               ! local 'density/temperature' gradient along i-bathymetric slope
+               zgdrho =  ( ztnb(ji+1,jj) - ztnb(ji,jj) )
+               ! sign of local i-gradient of density multiplied by the i-slope
+               zsign = SIGN( 0.5, - zgdrho    * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
+               zsigna= SIGN( 0.5, zunb(ji,jj) * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
+               zalphax(ji,jj)=( 0.5 + zsigna ) * ( 0.5 - zsign ) * umask(ji,jj,1)
+               ! 
+               ! local density gradient along j-bathymetric slope
+               zgdrho =  ( ztnb(ji,jj+1) - ztnb(ji,jj) )
+               ! sign of local j-gradient of density multiplied by the j-slope
+               zsign = SIGN( 0.5, -zgdrho     * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
+               zsigna= SIGN( 0.5, zvnb(ji,jj) * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
+               zalphay(ji,jj)=( 0.5 + zsigna ) * ( 0.5 - zsign ) * vmask(ji,jj,1)
+            END DO
+         END DO
+         !
       CASE ( 2 )               ! Linear formulation function of temperature and salinity
-      !
-      DO jj = 1, jpjm1
-         DO ji = 1, fs_jpim1   ! vector opt.            
-            ! local density gradient along i-bathymetric slope
-            zgdrho = - ( rbeta*( zsnb(ji+1,jj) - zsnb(ji,jj) )   &
-               &     -  ralpha*( ztnb(ji+1,jj) - ztnb(ji,jj) ) )
-            ! sign of local i-gradient of density multiplied by the i-slope
-            zsign = SIGN( 0.5, - zgdrho    * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
-            zsigna= SIGN( 0.5, zunb(ji,jj) * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
-            zalphax(ji,jj) = ( 0.5 + zsigna ) * ( 0.5 - zsign ) * umask(ji,jj,1)
-
-            ! local density gradient along j-bathymetric slope
-            zgdrho = - ( rbeta*( zsnb(ji,jj+1) - zsnb(ji,jj) )   &
-                   -    ralpha*( ztnb(ji,jj+1) - ztnb(ji,jj) ) )   
-            ! sign of local j-gradient of density multiplied by the j-slope
-            zsign = SIGN( 0.5, - zgdrho    * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
-            zsigna= SIGN( 0.5, zvnb(ji,jj) * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
-            zalphay(ji,jj) = ( 0.5 + zsigna ) * ( 0.5 - zsign ) * vmask(ji,jj,1)
-         END DO
-      END DO
-      !
-      CASE DEFAULT
-         WRITE(ctmp1,*) '          bad flag value for neos = ', neos
-         CALL ctl_stop( ctmp1 )
+         !
+         DO jj = 1, jpjm1
+            DO ji = 1, fs_jpim1   ! vector opt.            
+               ! local density gradient along i-bathymetric slope
+               zgdrho = - ( rn_beta *( zsnb(ji+1,jj) - zsnb(ji,jj) )   &
+                  &       - rn_alpha*( ztnb(ji+1,jj) - ztnb(ji,jj) ) )
+               ! sign of local i-gradient of density multiplied by the i-slope
+               zsign = SIGN( 0.5, - zgdrho    * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
+               zsigna= SIGN( 0.5, zunb(ji,jj) * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
+               zalphax(ji,jj) = ( 0.5 + zsigna ) * ( 0.5 - zsign ) * umask(ji,jj,1)
+               ! 
+               ! local density gradient along j-bathymetric slope
+               zgdrho = - ( rn_beta *( zsnb(ji,jj+1) - zsnb(ji,jj) )   &
+                  &       - rn_alpha*( ztnb(ji,jj+1) - ztnb(ji,jj) ) )   
+               ! sign of local j-gradient of density multiplied by the j-slope
+               zsign = SIGN( 0.5, - zgdrho    * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
+               zsigna= SIGN( 0.5, zvnb(ji,jj) * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
+               zalphay(ji,jj) = ( 0.5 + zsigna ) * ( 0.5 - zsign ) * vmask(ji,jj,1)
+            END DO
+         END DO
          !
       END SELECT
@@ -231,6 +221,6 @@
       
 # if defined key_vectopt_loop
-         jj = 1
-         DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
+         DO jj = 1, 1
+            DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
 # else   
          DO jj = 1, jpjm1
@@ -250,7 +240,5 @@
                   v_bbl(ji,jj,ikv) = zalphay(ji,jj) * vn(ji,jj,ikv) * ze3v / fse3v(ji,jj,ikv)       
                ENDIF
-# if ! defined key_vectopt_loop
-            END DO
-# endif
+            END DO
          END DO
 
@@ -261,6 +249,6 @@
 
 #if defined key_vectopt_loop
-         jj = 1
-         DO ji = 1, jpij   ! vector opt. (forced unrolling)
+         DO jj = 1, 1
+            DO ji = 1, jpij   ! vector opt. (forced unrolling)
 #else
          DO jj = 1, jpj
@@ -273,11 +261,9 @@
                   v_bbl(ji,jj,ikv) = zalphay(ji,jj) * vn(ji,jj,ikv)       
                ENDIF
-#if ! defined key_vectopt_loop
-            END DO
-#endif
+            END DO
          END DO
        
       ENDIF
-	  
+
 
       ! 5. Along sigma advective trend
@@ -286,6 +272,6 @@
 
 # if defined key_vectopt_loop
-      jj = 1
-      DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
+      DO jj = 1, 1
+         DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
 # else
       DO jj = 1, jpjm1
@@ -310,11 +296,9 @@
             zwz(ji,jj) = ( ( zfvj + ABS( zfvj ) ) * zsbb(ji  ,jj  )   &
                &          +( zfvj - ABS( zfvj ) ) * zsbb(ji  ,jj+1) ) * 0.5
-#if ! defined key_vectopt_loop
-         END DO
-#endif
-        END DO
-# if defined key_vectopt_loop
-      jj = 1
-      DO ji = jpi+2, jpij-jpi-1   ! vector opt. (forced unrolling)
+         END DO
+      END DO
+# if defined key_vectopt_loop
+      DO jj = 1, 1
+         DO ji = jpi+2, jpij-jpi-1   ! vector opt. (forced unrolling)
 # else
       DO jj = 2, jpjm1
@@ -332,7 +316,5 @@
             ta(ji,jj,ik) = ta(ji,jj,ik) + zta
             sa(ji,jj,ik) = sa(ji,jj,ik) + zsa
-#if ! defined key_vectopt_loop
-         END DO
-#endif
+         END DO
       END DO
 
@@ -365,8 +347,8 @@
 
       IF( ln_zps ) THEN
-	  
-# if defined key_vectopt_loop
-         jj = 1
-         DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
+ 
+# if defined key_vectopt_loop
+         DO jj = 1, 1
+            DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
 # else
          DO jj = 1, jpjm1
@@ -381,17 +363,15 @@
                ze3u = MIN( fse3u(ji,jj,iku1), fse3u(ji,jj,iku2) ) 
                ze3v = MIN( fse3v(ji,jj,ikv1), fse3v(ji,jj,ikv2) ) 
-	       
+
                zwu(ji,jj) = zalphax(ji,jj) * e2u(ji,jj) * ze3u  
                zwv(ji,jj) = zalphay(ji,jj) * e1v(ji,jj) * ze3v
-#if ! defined key_vectopt_loop
-            END DO
-#endif
+            END DO
          END DO  
-	
+         !
       ELSE
-
-# if defined key_vectopt_loop
-         jj = 1
-         DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
+         !
+# if defined key_vectopt_loop
+         DO jj = 1, 1
+            DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
 # else
          DO jj = 1, jpjm1
@@ -402,15 +382,13 @@
                zwu(ji,jj) = zalphax(ji,jj) * e2u(ji,jj) * fse3u(ji,jj,iku) 
                zwv(ji,jj) = zalphay(ji,jj) * e1v(ji,jj) * fse3v(ji,jj,ikv) 
-#if ! defined key_vectopt_loop
-            END DO
-#endif
-         END DO
-
+            END DO
+         END DO
+         !
       ENDIF
  
 
 # if defined key_vectopt_loop
-      jj = 1
-      DO ji = jpi+2, jpij-jpi-1   ! vector opt. (forced unrolling)
+      DO jj = 1, 1
+         DO ji = jpi+2, jpij-jpi-1   ! vector opt. (forced unrolling)
 # else
       DO jj = 2, jpjm1
@@ -426,8 +404,6 @@
                &   ) / zbt
 
-# if ! defined key_vectopt_loop
-         END DO
-# endif
-        END DO
+         END DO
+      END DO
 
       ! 7. compute additional vertical velocity to be used in t boxes
@@ -442,7 +418,5 @@
          END DO
       END DO
-
-      ! Boundary condition on w_bbl   (unchanged sign)
-      CALL lbc_lnk( w_bbl, 'W', 1. )
+      CALL lbc_lnk( w_bbl, 'W', 1. )      ! Boundary condition on w_bbl   (unchanged sign)
 
       CALL iom_put( "uoce_bbl", u_bbl )   ! bbl i-current      
